LeetCode刷题之31.下一个排列

文章目录

  • [1. 题目](#1. 题目)
  • 2.分析
  • 3.解答
    • [3.1 先排序,后交换](#3.1 先排序,后交换)
    • [3.2 先交换,后排序](#3.2 先交换,后排序)

1. 题目

整数数组的一个 排列 就是将其所有成员以序列或线性顺序排列。

  • 例如,arr = 1,2,3 ,以下这些都可以视作 arr 的排列:1,2,3、1,3,2、3,1,2、2,3,1 。

整数数组的 下一个排列 是指其整数的下一个字典序更大的排列。更正式地,如果数组的所有排列根据其字典顺序从小到大排列在一个容器中,那么数组的 下一个排列 就是在这个有序容器中排在它后面的那个排列。如果不存在下一个更大的排列,那么这个数组必须重排为字典序最小的排列(即,其元素按升序排列)。

  • 例如,arr = 1,2,3 的下一个排列是 1,3,2 。
  • 类似地,arr = 2,3,1 的下一个排列是 3,1,2 。
  • 而 arr = 3,2,1 的下一个排列是 1,2,3 ,因为 3,2,1 不存在一个字典序更大的排列。

给你一个整数数组 nums ,找出 nums 的下一个排列。

必须 原地 修改,只允许使用额外常数空间。

2.分析

这里需要找下一个字典序更大的排列,那么意味着要从数组的后端入手。如果最后两个元素原本就是升序的,那么就直接交换这两个元素就好了,这个组合即使下一个更大的组合。

但是,如果这两个元素不是升序的,那么交换这两个元素反而导致拍列更小。因此,必须要找到从后向前数的第一个升序排列的两个相邻元素。找到之后,交换这两个元素即可。

但是,交换后的元素依然不一定是下一个更大排列组合。如5,7,6,4这个排列,交换5和7,得到的是7,5,6,4这个组合,显然不是下一个更大排列,毕竟手动排列组合一下,发现下一个组合应该是6,4,5,7

那么,应该是考虑从后向前第一个升序段的后一个元素开始,将后面所有的元素按字典排序,然后找到紧挨着升序点前一个元素的那个元素,将其交换即可。

或者找到紧挨着升序段前一个元素的数据,将其进行交换,然后将从升序段后一个元素开始的数据,按字典方式排序。

3.解答

3.1 先排序,后交换

java 复制代码
public class Solution {
	public void nextPermutation(int[] nums) {
        if (nums.length <= 1) return;
        int len = nums.length;

        for (int i = len - 1; i > 0;i--) {
            if (nums[i] > nums[i - 1]) {
                Arrays.sort(nums, i, len);

                for (int j = i; j < len; j++) {
                    if (nums[j] > nums[i - 1]) {
                        int temp = nums[j];
                        nums[j] = nums[i - 1];
                        nums[i - 1] = temp;
                        return;
                    }
                }
            }
        }

        Arrays.sort(nums);
        }
}

3.2 先交换,后排序

java 复制代码
public class Soultion {
	public void nextPermutation(int[] nums) {
		if (nums.length <= 1) return;
		int i = nums.length - 2;
		int j = nums.length - 1;
		int k = nums.length - 1;
		
		while (i >= 0 && nums[i] >= nums[j]) {
			i--;
			j--;
		} 

		if (i >= 0) {
			while (nums[i] > num[k]) {
				k--;
			}
			swap(nums, i, k);
		}
		
		Arrays.sort(nums, j, nums.length);
	}
	
	private void swap(int[], int i, int k) {
		int temp = nums[i];
		nums[i] = nums[k];
		nums[k] = temp;
	}
}
相关推荐
hanlin038 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.8 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
Scintilla_y11 小时前
DAY2 滑动窗口
算法·leetcode·散列表
特立独行的猫a12 小时前
仓颉语言UI开发实战:我用仓颉写了个桌面版力扣
算法·leetcode·ui·tauri·仓颉·cj-tarui
y1su12 小时前
Leetcode 动态规划 模板
java·数据结构·算法·leetcode·动态规划
All for pursuit.13 小时前
【位运算-3】136.只出现一次的数字
数据结构·c++·算法·leetcode
All for pursuit.15 小时前
【完结】LeetCodeHot100题 详细解题过程及代码汇总
数据结构·c++·算法·leetcode
mmmmath_316 小时前
LeetCode.101.对称二叉树
数据结构·leetcode
mmmmath_320 小时前
LeetCode.637.二叉树的层平均值
算法·leetcode
Tisfy21 小时前
LeetCode 2913.子数组不同元素数目的平方和 I:第一题先常数很大的O(n^2)
算法·leetcode·题解·模拟·暴力